/*
 * $RCSfile: ipcp_i.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994  Arizona Board of Regents
 *
 * $Log: ipcp_i.h,v $
 * Revision 1.1  1994/10/24 20:48:44  andrey
 * Initial revision
 *
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/24 20:48:44 $
 */

/*
 * ipcp internal state
 */

/* ------------------- Protocol headers ----------------------------------- */

/*
 * configuration options packet defs
 */

typedef struct
{
  IPhost Host;
} ADDRESS_opt;

typedef struct
{
  u_char max_slot_id;
  u_char comp_slot_id;
} COMPRESSION_opt;

#define	ADDRESS_opt_init(opt_ptr) \
    ((opt_ptr)->type=IPCP_ADDRESS, (opt_ptr)->length=6)

#define	COMPRESSION_opt_init(opt_ptr) \
    ((opt_ptr)->type=IPCP_COMPRESSION, (opt_ptr)->length=6)

#define	free_unknown(UNKOWN_opt_ptr)\
  (FREE((UNKOWN_opt_ptr)->buf), FREE(UNKOWN_opt_ptr))

/* ------------------- XObj Protocol specific stuff ----------------------- */

typedef struct {
  PPP_config  implem_options;	/* implementation options */
  PPP_options rom_ipcp_options;	/* rom file options */
  XObj	TheSession;		/* the only session */
} PSTATE;

#define	PSTATE_init(PSTATE_ptr)\
	{\
          PPP_config_init(&((PSTATE_ptr)->implem_options));\
	  PPP_options_init(&((PSTATE_ptr)->rom_ipcp_options));\
          (PSTATE_ptr)->TheSession = ERR_XOBJ;\
        }

/* ------------------- XObj Session specific stuff ----------------------- */

typedef struct {
  PPP_options * my_agreed_options;	/* options that are ok */
  PPP_options * my_nego_options;	/* options still in negotiation */
  PPP_options * my_un_nego_options;	/* rejected options */

  PPP_options * peer_agreed_options;	/* options that are ok */
  PPP_options * peer_nego_options;	/* options still in negotiation */
  PPP_options * peer_un_nego_options;	/* rejected options */

  FSM_info * ipcp_fsm;
} SSTATE;
