/*
 * $RCSfile: symbol.h,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/13 17:43:30 $
 */

extern int NestLevel;

extern void init_symbols(void);

extern void set_to_string (Constant *theconst, char *string);
extern void set_to_int (Constant *theconst, char *string);
extern void set_to_float (Constant *theconst, char *string);

extern void pushlevel (void);
extern void poplevel (void);

extern Symbol *ident_to_sym (char *theident);
extern Symbol *cat_sym (Symbol *one, Symbol *two);
extern Type *make_specifier (Constant *theconst);
extern Type *or_specifier (Type *one, Type *two);
extern Symbol *distribute_specifier (Type *thetype, Symbol *symlist);
extern Type *find_struct_def (char *name);
extern Type *finish_struct_def (Type *spec, char *name, Symbol *syms);
extern Type *add_to_struct_defs (Type *stdef, int level);
extern Type *make_typedef (Type *thetype);
extern Symbol *add_to_sym_or_type_table (Symbol *syms);
extern Type *find_type (char *name);
extern Symbol *make_array (Symbol *sym, Expr *theexpr);
extern Symbol *make_pointer (Symbol *sym);
extern Symbol *make_function (Symbol *sym, Symbol* param_list);
extern Symbol *complete_function (Type *spec, Symbol *function, Expr *body);
extern Symbol *add_type_info (Symbol *sym, Type *info);
extern Type *make_bitfield_constructor( Constant* size, Constant* memsize,
				 Constant* alignment, Type* bit_order );
extern Type *make_type_info (Constant *size, Constant *msize,
			     Constant *alignment, Constant *offset,
			     Expr *byte_order);
extern void check_and_set_type_data (Symbol *syms);
extern Symbol *find_sym (char *name);
extern void set_all_sym_type_info (Symbol *sym);
extern TypeData *make_default_typedata (void);

extern Constant *add_more_bytes (Constant* theconstant, Constant *bytes);

extern Type *make_native_bitfield (Expr *theexpr);
extern Type *add_bitfield_constructor (Type *thetype, Type *bits);
extern Type *add_more_bits (Type *thetype, Constant *bits);
extern Constant *cat_const (Constant *one, Constant *two);
extern Symbol *make_bitfield (Symbol *decl, Type *bitfield);
extern int symbol_bit_size (Symbol *sym);
extern Type *copy_type(Type *thetype);
extern char *local_name( char* name );
extern char *return_name( char* name );
extern void variable_length_array( Type* var_len_type, VarLen* var_len_data );
extern Expr *sizeof_type( Type* type );
extern Expr *sizeof_symbol( Expr* expr );
extern char *spec_type_to_string (Type* type);
